<template>
    <div class="profile">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
                <menu-bar />
            </v-col>
            <v-col>
                <v-row
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.PROFILE') }}
                        </h1>
                    </v-col>
                </v-row>
                <v-form
                    v-show="pageLoaded"
                    ref="profileForm"
                    lazy-validation
                    @submit.prevent
                >
                    <v-row
                        :class="[
                            { 'pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                            {
                                'pl-16 pr-16 pb-16':
                                    $vuetify.breakpoint.mdAndUp,
                            },
                        ]"
                    >
                        <v-col cols="12">
                            <!-- EDIT PROFILE FORM -->
                            <v-row>
                                <v-col cols="12" md="6" class="form-field pb-0"
                                    ><!-- FIRST NAME -->
                                    <v-text-field
                                        ref="firstName"
                                        v-model="form.firstName.value"
                                        :label="$t('form.firstName.text')"
                                        :placeholder="
                                            $t('form.firstName.placeholder')
                                        "
                                        :error-messages="form.firstName.error"
                                        solo
                                        required
                                        :rules="[requiredRules]"
                                    ></v-text-field
                                ></v-col>
                                <v-col cols="12" md="6" class="form-field pb-0"
                                    ><!-- LAST NAME -->
                                    <v-text-field
                                        ref="lastName"
                                        v-model="form.lastName.value"
                                        :label="$t('form.lastName.text')"
                                        :placeholder="
                                            $t('form.lastName.placeholder')
                                        "
                                        :error-messages="form.lastName.error"
                                        solo
                                        required
                                        :rules="[requiredRules]"
                                    ></v-text-field
                                ></v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="12" md="6" class="form-field py-0"
                                    ><!-- EMAIL -->
                                    <v-text-field
                                        ref="email"
                                        v-model="form.email.value"
                                        :label="$t('form.email.text')"
                                        :placeholder="
                                            $t('form.email.placeholder')
                                        "
                                        solo
                                        disabled
                                        :rules="[requiredRules, requiredEmail]"
                                        :error-messages="form.email.error"
                                    ></v-text-field
                                ></v-col>
                                <v-col cols="12" md="6" class="form-field py-5 py-md-0"
                                    ><!-- MOBILE -->
                                    <phone-input
                                        v-model="form.mobile.value"
                                        :errors="form.mobile.error"
                                        :value="form.mobile.value"
                                    />
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="12" md="6" class="form-field py-0"
                                    ><!-- GENDER -->
                                    <v-select
                                        ref="gender"
                                        v-model="form.gender.value"
                                        :label="$t('form.gender.text')"
                                        :items="genderList"
                                        item-text="name"
                                        item-value="id"
                                        :error-messages="form.gender.error"
                                        solo
                                    ></v-select
                                ></v-col>
                                <v-col cols="12" md="6" class="form-field py-0"
                                    ><!-- SIZE -->
                                    <v-select
                                        ref="size"
                                        v-model="form.size.value"
                                        :label="$t('form.size.text')"
                                        :items="sizeList"
                                        item-text="name"
                                        item-value="id"
                                        :error-messages="form.size.error"
                                        solo
                                    ></v-select
                                ></v-col>
                            </v-row>
                            <v-row class="mt-0">
                                <v-col cols="12" md="6">
                                    <v-expansion-panels>
                                        <v-expansion-panel>
                                            <v-expansion-panel-header
                                                class="font-metropolis-regular"
                                            >
                                                {{
                                                    deliveryDate != ''
                                                        ? formatDate(
                                                              deliveryDate
                                                          )
                                                        : $t(
                                                              'form.dob.placeholder'
                                                          )
                                                }}
                                            </v-expansion-panel-header>
                                            <v-expansion-panel-content>
                                                <client-only>
                                                    <date-picker
                                                        v-model="deliveryDate"
                                                        format="yyyy/MM/dd"
                                                        :inline="true"
                                                /></client-only>
                                            </v-expansion-panel-content>
                                        </v-expansion-panel>
                                    </v-expansion-panels>
                                </v-col>
                            </v-row>
                            <!-- SUBMIT BUTTON -->
                            <v-row>
                                <v-col>
                                    <v-btn
                                        :block="$vuetify.breakpoint.smAndDown"
                                        class="lowercase br-0 pl-10 pr-10 font-syne-bold"
                                        color="badge"
                                        :loading="loading"
                                        :disabled="isButtonDisabled"
                                        @click="validateForm"
                                        >{{ $t('buttons.saveBtn') }}</v-btn
                                    >
                                </v-col>
                            </v-row>
                        </v-col>
                    </v-row>
                </v-form>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import moment from 'moment'
import User from '~/utils/models/user'
import MenuBar from '~/components/dashboard/menuBar.vue'

Vue.component('menu-bar', MenuBar)
const { VueMaskDirective } = require('v-mask')

Vue.directive('mask', VueMaskDirective)
@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            titleTemplate: '%s | ' + this.$t('dashboard.menu.HOME'),
            title: this.$t('dashboard.menu.PROFILE'),
        }
    },
    computed: {
        ...mapGetters({
            user: 'user/getUser',
        }),
    },
})
export default class Profile extends Vue {
    // Data
    $refs!: { profileForm: HTMLFormElement }
    ref: any = this.$refs
    pageLoaded: boolean = false
    user!: User
    selectedPage: Number = 1 // profile
    loading: Boolean = false
    isButtonDisabled: Boolean = false
    formHasErrors: Boolean = false
    form: { [key: string]: any } = {
        firstName: {
            value: '',
            error: null,
            requestKey: 'first_name',
        },
        lastName: {
            value: '',
            error: null,
            requestKey: 'last_name',
        },
        email: {
            value: '',
            error: null,
            requestKey: 'email',
        },
        password: {
            value: '',
            error: null,
            requestKey: 'password',
        },
        mobile: {
            value: '',
            error: null,
            requestKey: 'mobile',
        },
        gender: {
            value: '',
            error: null,
            requestKey: 'gender',
        },
        dob: {
            value: '',
            error: null,
            requestKey: 'dob',
        },
        size: {
            value: '',
            error: null,
            requestKey: 'size',
        },
    }

    genderList: any = [
        { id: 1, name: 'Male' },
        { id: 2, name: 'Female' },
        { id: 3, name: 'Unisex' },
    ]

    sizeList: any = [
        { id: 1, name: 'Extra Small' },
        { id: 2, name: 'Small' },
        { id: 3, name: 'Medium' },
        { id: 4, name: 'Large' },
        { id: 5, name: 'Extra Large' },
        { id: 6, name: 'Free Size' },
    ]

    deliveryDate: any = ''

    // Methods
    validateForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.profileForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    submit() {
        this.isButtonDisabled = true
        this.loading = true

        if (this.form.mobile.value.charAt(3) === '0') {
            const valueFirst = this.form.mobile.value.slice(0, 3)
            const valueSecond = this.form.mobile.value.slice(4)
            this.form.mobile.value = valueFirst + valueSecond
        }

        this.$api.user
            .update(
                this.form.firstName.value,
                this.form.lastName.value,
                this.form.mobile.value,
                this.form.gender.value,
                this.formatDate(this.deliveryDate),
                this.form.size.value
            )
            .then(() => {
                // Set store to new values
                this.$store.commit(
                    'user/setUserFirstName',
                    this.form.firstName.value
                )
                this.$store.commit(
                    'user/setUserLastName',
                    this.form.lastName.value
                )
                this.$store.commit('user/setUserMobile', this.form.mobile.value)
                this.$store.commit('user/setUserGender', this.form.gender.value)
                this.$store.commit(
                    'user/setUserDob',
                    this.formatDate(this.deliveryDate)
                )
                this.$store.commit('user/setUserSize', this.form.size.value)

                // Reset error messages
                this.form.firstName.error = null
                this.form.lastName.error = null
                this.form.mobile.error = null
                this.form.gender.error = null
                this.form.dob.error = null
                this.form.size.error = null

                // Display snackbar
                const val = {
                    text: this.$t('snackbar.updateProfileSucess'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                this.isButtonDisabled = false
                this.loading = false
            })
            .catch((error) => {
                if (error.response.status === 401) {
                    return
                }

                this.isButtonDisabled = false
                this.loading = false

                // Get errors object
                const errors = error.response.data.errors

                // Get keys of error
                const errorKeys: string[] = Object.keys(errors)
                const formKeys: string[] = Object.keys(this.form)

                // Set error messages
                for (const errorKey of errorKeys) {
                    for (const formKey of formKeys) {
                        if (this.form[formKey].requestKey === errorKey) {
                            this.form[formKey].error = errors[errorKey].reduce(
                                (message = '', currentMessage: string) => {
                                    return message + ' ' + currentMessage
                                }
                            )
                        }
                    }
                }
            })
    }

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    requiredEmail(v: string) {
        if (v) {
            if (v.length > 0) {
                const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
                return (
                    pattern.test(v) || this.$t('form.validation.invalidEmail')
                )
            }
        }
        return this.$t('form.validation.required')
    }

    formatDate(date) {
        return moment(date).format('yyyy/MM/DD')
    }

    mounted() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
        if (this.user) {
            // set profile details

            this.form.firstName.value = this.user.firstName
            this.form.lastName.value = this.user.lastName
            this.form.email.value = this.user.email
            this.form.mobile.value = this.user.mobile ?? ''
            this.form.gender.value = this.user.gender
            this.deliveryDate = this.user.dob
            this.form.size.value = this.user.size
        }

        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
    }
}
</script>
